function util_get_time(){
    return new Date().getTime() ; // 1622427445085
}

function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function utl_get_website(url) {
    url = unescape(url);
    var theRequest = new Object();
    if (url.indexOf("?") != -1) {
        var str = url.substr(1);
        strs = str.split("&");
        for (var i = 0; i < strs.length; i++) {
            theRequest[strs[i].split("=")[0]] = unescape(strs[i].split("=")[1]);
        }
    }
    if(theRequest.hasOwnProperty('url')){
        return theRequest['url'];
    }
    return '';
}

function shangjia_items_update(shangjia_items = []){
    if(localStorage.getItem("shangjia_items") == null){
        localStorage['shangjia_items'] = JSON.stringify([]);
    }
    shangjia_items_list = JSON.parse(localStorage['shangjia_items']);
    //
    for(let i=0;i<shangjia_items.length;i++){
        let is_exists = false;
        for(let j=0;j<shangjia_items_list.length;j++){
            if(shangjia_items_list[j]['Domain'] == shangjia_items[i]['Domain']){
                is_exists = true;
                break;
            }
        }
        if(is_exists == false){
            shangjia_items_list.push(shangjia_items[i]);
        }
    }
    //
     localStorage['shangjia_items'] = JSON.stringify(shangjia_items_list);
    //
}

function shangjia_items_get(){
    if(localStorage.getItem("shangjia_items") == null){
        localStorage['shangjia_items'] = JSON.stringify([]);
    }
    shangjia_items_list = JSON.parse(localStorage['shangjia_items']);
    //
    return shangjia_items_list;
}

function ajax_get(url){
    console.log('url:'+url);
    let _html_result = '';
    var exhibitors_ajax = $.ajax({
             //url: 'https://www.google.com/maps/place/VIP+Wigs+%26+Prosthesis/@37.9009282,-122.0623831,17z/data=!3m1!4b1!4m6!3m5!1s0x808561953bedbbfd:0xe9365860131da46b!8m2!3d37.9009282!4d-122.0623831!16s%2Fg%2F1tcxpx4r?authuser=0&hl=en',
             url:url,
             data: {},
             type: 'GET',
             async:false,
             crossDomain: true,
             //timeout:20000,//20 s
             dataType: 'html',
             contentType:'text/html; charset=utf-8',
             //dataType: 'json',
             //contentType:'application/json;charset=utf-8',
             success: function(data) {
                 _html_result = data;
             },
             error: function(xhr, textStatus, errorThrown) {
                _html_result = 'error';
            }
         });
    return _html_result;
}

$(document).ready(function () {
    let current_url = window.location.href;
    if(current_url.indexOf('UcsSearchAction')!=-1){
        setTimeout(function (){
                   extract_shangjias();
                },2000);
    }
});

function extract_shangjias(){
    var message = {
        action: 'can_zidong_caiji',
        info: ''
    };
    chrome.runtime.sendMessage(message,(msg)=> {
        console.log('extract_shangjias zidong_caiji_next', msg)
        let msgobj = JSON.parse(msg);
        console.log(msgobj['state']);
        if (msgobj['state'] == 0) { //可以自动采集
            console.log('extract_shangjias zidong_caiji_next a1');
            //
             var shangjia_infos = [];
            $('.results--row article').each(function (){
                //
                var shangjia_name = $(this).find('a.businessCapsule--title').text();
                var shangjia_website = '';
                var shangjia_domain = '';
                shangjia_website = $(this).find('a.businessCapsule--ctaItem').attr('href');
                if(shangjia_website){
                   shangjia_domain = shangjia_website.replace('https://', '')
                                .replace('http://','')
                                .replace('www.','');
                   if(shangjia_domain){
                       shangjia_domain = shangjia_domain.split("/")[0];
                   }
                }
                console.log('shangjia_domain:'+shangjia_domain);
                if(shangjia_domain==''){
                    shangjia_domain = shangjia_name.trim()+'无';
                    shangjia_website = shangjia_name.trim()+'无';
                }
                //
                var shangjia_year = $(this).find('.years-in-business .number').text();
                //
                var shangjia_info = $(this).find('.businessCapsule--classification').text();
                var shangjia_phone = $(this).find('.business--telephoneNumber').text();
                var shangjia_address = $(this).find("span[itemprop='address']").text();
                //
                //if(shangjia_website){
                var shangjia_info = {
                    'Name': shangjia_name,
                    'Website': shangjia_website,
                    'Domain': shangjia_domain,
                    'Phone': shangjia_phone,
                    'Address': shangjia_address,
                    'Info':shangjia_info
                };
                shangjia_infos.push(shangjia_info);
                //}
                //
            });
            shangjia_items_update(shangjia_infos);
            //自动翻页采集
            let next_a = $("a.pagination--next").attr('href');
            if(next_a){
                setTimeout(function (){
                   window.location.href = next_a;
                },15000);
            }
            //
        }
    });
}

var navigation_url = '';

function extract_get_catalog_products_num(){
    var shangjia_items = shangjia_items_get();
    var maijia_num = 0;
    if(typeof shangjia_items != 'undefined'){
        maijia_num = shangjia_items.length;
    }
    return maijia_num;
}

function xintiao(){
    var shangjia_items = shangjia_items_get();
    var maijia_num = 0;
    if(typeof shangjia_items != 'undefined'){
        maijia_num = shangjia_items.length;
    }
    var message = {
        action: 'update-shangjia-num',
        info: '',
        maijia_num: maijia_num
    };
    send_message_to_popup(message);
}
setInterval(xintiao, 3000);

function getUrlParam(url,name) {
    if(url){
        console.log('url:'+url);
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
        var url_list = url.split('?');
        if(url_list.length>=2){
            var r = url_list[1].match(reg);  //匹配目标参数
            if (r != null) return unescape(r[2]); return ''; //返回参数值
        }
    }
    return '';
}

async function fetch_request(url){
     var shangjia_infos = [];
            let options = {
                method: 'get',
                headers: {
                    'Content-Type':'application/json;charset=utf-8'
                },
                // body: JSON.stringify(res)
            }
            // Fake api for making post requests
            //console.log('fetch_request url:'+url);
            await fetch(url,options).then(res =>
                            res.json()).then(d => {
                                //console.log('fetch_request response:');
                                //console.log(d);
                                //
                                //console.log(d);
                                var data_d_val = d['searchPageProps']['mainContentComponentsListProps'];
                                //console.log(data_d_val);

                                var shangjia_items = data_d_val;
                                for (j = 1; j < shangjia_items.length; j++) {
                                    //
                                    var shangjia_item = shangjia_items[j];
                                    //
                                    if(shangjia_item.hasOwnProperty('searchResultBusiness')){
                                        var searchResultBusiness = shangjia_item['searchResultBusiness'];
                                        //
                                        var shangjia_name = searchResultBusiness['name'];
                                        var shangjia_website = '';
                                        var shangjia_domain = '';
                                        if(searchResultBusiness.hasOwnProperty('website')){
                                            var website_dict = searchResultBusiness['website'];
                                            if(website_dict && website_dict.hasOwnProperty('href')){
                                                var shangjia_website = searchResultBusiness['website']['href'];
                                                shangjia_website = unescape(shangjia_website);
                                                //
                                                if(shangjia_website.indexOf('adredir') > -1){
                                                    let ad_shangjia_website = 'https://www.yelp.com'+shangjia_website;
                                                    shangjia_website = utl_get_website(ad_shangjia_website);
                                                }
                                                //
                                                shangjia_domain = shangjia_website.replace('https://', '')
                                                    .replace('http://','')
                                                    .replace('www.','');
                                            }
                                        }
                                        var shangjia_categories = searchResultBusiness['categories'];
                                        var shangjia_categories_str = '';
                                        if(typeof shangjia_categories != 'undefined'){
                                            for(let l=0;l<shangjia_categories.length;l++){
                                                shangjia_categories_str+=shangjia_categories[l]['title']+',';
                                            }
                                            shangjia_categories_str = shangjia_categories_str.substring(0, shangjia_categories_str.length-1);
                                        }
                                        //
                                        var fulladdress = searchResultBusiness['formattedAddress'];

                                        var shangjia_info = {
                                            'Name': shangjia_name,
                                            'Website': shangjia_website,
                                            'Domain': shangjia_domain,
                                            'Fulladdress': fulladdress,
                                            'Categories': shangjia_categories_str
                                        };
                                        shangjia_infos.push(shangjia_info);
                                    }
                                }
                                //
                            })
    return shangjia_infos;
}

function extract_catalog_products_export_clean_com(){
    //
    var shangjia_infos = [];

    var q_name = $("input[name='keywords']").val();
    var q_loaction = $("input[name='location']").val();
    var expire_data = get_expire();
    var expire_date_dict = expire_data[0];
    var expire_date = expire_date_dict['expire'];
    if(1) {
        //
        shangjia_infos.push({
            'Name': q_name+'_'+q_loaction,
            'Website': window.location.href,
            'Domain': '',
            'Phone': '',
            'Address': '',
            'Info':'',
        })
        //
        var shangjia_items_list = shangjia_items_get();
        for(let i=0;i<shangjia_items_list.length;i++){
            shangjia_infos.push(shangjia_items_list[i]);
        }
        //
    }
    //console.log('shangjia_infos2');
    //console.log(shangjia_infos);
     var catalog_products = {
         'shangjia_infos': shangjia_infos,
         'file_name': q_name,
         'expire':get_expire()
     }
     //localStorage.removeItem("tbm_map_urls");
     //if(localStorage.getItem("shangjia_items") == null){
      //   localStorage['shangjia_items'] = JSON.stringify([]);
     //}
    //console.log('catalog_products');
    //console.log(catalog_products);
     //console.log('b2');
    return catalog_products;
}

function extract_catalog_products_export_clean(){
    let current_url = window.location.href;
    return extract_catalog_products_export_clean_com();

}

function extract_catalog_products_clean(){
    localStorage.removeItem("shangjia_items");

   // if(localStorage.getItem("tbm_map_urls") == null){
        localStorage['shangjia_items'] = JSON.stringify([]);
   // }

    return  {
         'shangjia_items': []
     }
}

function set_expire(date=''){
    console.log('set_expire:'+date);
    var expire = [];
    if(localStorage.getItem("expire") == null){
        localStorage['expire'] = JSON.stringify([{'expire':''}]);
    }
    localStorage['expire'] = JSON.stringify([{'expire':date}]);

    expire = JSON.parse(localStorage['expire']);
    return expire;
}

function get_expire(){
    if(localStorage.getItem("expire") == null){
        localStorage['expire'] = JSON.stringify([{'expire':''}]);
    }
    expire = JSON.parse(localStorage['expire']);
    return expire;
}

// get popup2content info
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    if(request.action == 'extract_get_catalog_products_num') {
        catalog_products_url = extract_get_catalog_products_num();
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract-catalog-products-export-clean'){
        catalog_products_url = extract_catalog_products_export_clean();
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract_catalog_products_clean'){
        catalog_products_url = extract_catalog_products_clean();
        sendResponse(catalog_products_url);
    }else if(request.action == 'set_expire') {
        expire_date = set_expire(request.date);
        sendResponse(expire_date);
    }else if(request.action == 'get_expire'){
        expire_date = get_expire();
        sendResponse(expire_date);
    }
})
//

//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}

//send message to background
function send_message_to_background_yellowpages_co_tg_get_shangjia_data(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
        //
        let shangjia_data = JSON.parse(msg.state)
        if(shangjia_data['Domain'] == ''){
            $('.pager-nav').append(shangjia_data['Yellowpages Url']+'未采集到，可以尝试稍后刷新下当前页(或者更换代理再刷新)，会重新采集<br />');
        }else{
            var shangjia_items = [];
            if(localStorage.getItem("shangjia_items") == null){
                localStorage['shangjia_items'] = JSON.stringify([]);
            }
            shangjia_items = JSON.parse(localStorage['shangjia_items']);
            shangjia_items.push(shangjia_data);
            shangjia_items_update(shangjia_items);
            $('.pager-nav').append(shangjia_data['Name']+' 已提取完成<br />');
        }
        //
    })
}